import * as React from 'react';
import { IProps, TEvent } from './types';
declare class List<Value = string> extends React.Component<IProps<Value>> {
    listRef: React.RefObject<HTMLElement>;
    ghostRef: React.RefObject<HTMLElement>;
    topOffsets: number[];
    itemTranslateOffsets: number[];
    initialYOffset: number;
    lastScroll: number;
    needle: number;
    afterIndex: number;
    state: {
        itemDragged: number;
        selectedItem: number;
        initialX: number;
        initialY: number;
        targetX: number;
        targetY: number;
        targetHeight: number;
        targetWidth: number;
        liveText: string;
        scrollingSpeed: number;
        scrollWindow: boolean;
    };
    componentDidMount(): void;
    componentDidUpdate(_prevProps: any, prevState: {
        scrollingSpeed: number;
    }): void;
    doScrolling: () => void;
    getChildren: () => Element[];
    static defaultProps: {
        transitionDuration: number;
        lockVertically: boolean;
        voiceover: {
            item: (position: number) => string;
            lifted: (position: number) => string;
            moved: (position: number, up: boolean) => string;
            dropped: (from: number, to: number) => string;
            canceled: (position: number) => string;
        };
    };
    calculateOffsets: () => void;
    getTargetIndex: (e: TEvent) => number;
    onMouseDown: (e: React.MouseEvent<Element, MouseEvent>) => void;
    onTouchStart: (e: React.TouchEvent<Element>) => void;
    getYOffset: () => number;
    onStart: (target: HTMLElement, clientX: number, clientY: number, index: number) => void;
    onMouseMove: (e: MouseEvent) => null | undefined;
    onTouchMove: (e: TouchEvent) => null | undefined;
    onWheel: (e: React.WheelEvent<Element>) => void;
    onMove: (clientX: number, clientY: number) => null | undefined;
    moveOtherItems: () => void;
    autoScrolling: (clientY: number) => void;
    animateItems: (needle: number, movedItem: number, offset: number, animateMovedItem?: boolean) => void;
    onEnd: () => void;
    onKeyDown: (e: React.KeyboardEvent<Element>) => void;
    render(): JSX.Element;
}
export default List;
